#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
main()
{
   Display *d;      Window w;
   GC gc;           XEvent e;
   Atom a1, a2;     int x, y;
   d = XOpenDisplay (NULL);
   w = XCreateSimpleWindow (d, RootWindow (d, 0), 400, 400,
                            200, 200, 2, 0, 1);
   XMapWindow (d, w);
   gc = XCreateGC (d, w, 0, 0);

   a1 = XInternAtom (d, "My Window", False);
   XChangeProperty (d, RootWindow (d, 0), a1, XA_WINDOW, 32,
                    PropModeReplace, &w, 1);
   a2 = XInternAtom (d, "Rectangle", False);

   while (1)
     {
       XNextEvent (d, &e);
       if (e.type == ClientMessage && e.xclient.message_type == a2)
         { x = e.xclient.data.l[0];
           y = e.xclient.data.l[1];
           XDrawRectangle (d, w, gc, x, y, 4, 4);
         }
     }
}
