#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#define MARGIN      5
main(argc, argv)
int argc;
char **argv;
{
   Display *d;     Window w;   XFontStruct *fs;
   XSizeHints sh;  int unit_w, unit_h;

   d = XOpenDisplay (NULL);
   fs = XLoadQueryFont (d, "8x16");
   unit_w = fs->max_bounds.width;
   unit_h = fs->ascent + fs->descent;

   w = XCreateSimpleWindow (d, RootWindow (d, 0),
                            atoi(argv[3]), atoi(argv[4]),
                            unit_w * atoi(argv[1]) + MARGIN * 2,
                            unit_h * atoi(argv[2]) + MARGIN * 2,
                            0, 0, 1);

   sh.flags = (USPosition | USSize | PBaseSize
               | PResizeInc | PMinSize | PMaxSize);
   sh.base_width  = MARGIN * 2;
   sh.base_height = MARGIN * 2;
   sh.width_inc   = unit_w;
   sh.height_inc  = unit_h;
   sh.min_width   = unit_w * 20 + MARGIN * 2;
   sh.min_height  = unit_h *  2 + MARGIN * 2;
   sh.max_width   = unit_w * 80 + MARGIN * 2;
   sh.max_height  = unit_h * 40 + MARGIN * 2;

   XSetWMNormalHints (d, w, &sh);

   XMapWindow (d, w);
   XFlush (d);
   getchar ();
}
